var _nodePath = require("node:path");
var _nodeFs = require("node:fs");
var _nodeRepl = require("node:repl");
var _format = require("../library/common/format.js");
var _time = require("../library/common/time.js");
var _check = require("../library/common/check.js");
var _verify = require("../library/common/verify.js");
var _Stream = require("../library/node/data/Stream.js");
var _File = require("../library/node/fs/File.js");
var _Pid = require("../library/node/module/Pid.js");
const modulePathHack = newPath => {
  if (!newPath.endsWith("node_modules")) return;
  const modulePaths = require("node:module")._resolveLookupPaths("modulePaths");
  (0, _verify.basicArray)(modulePaths);
  modulePaths.includes(newPath) || modulePaths.push(newPath);
};
exports.modulePathHack = modulePathHack;
const patchModulePath = () => modulePathHack((0, _nodePath.resolve)(module.filename, "../../../../"));
exports.patchModulePath = patchModulePath;
const evalScript = (evalScriptString, evalScriptPath, evalArgv, evalOption) => (0, eval)(`async (evalArgv, evalOption, __filename, __dirname, require) => { ${evalScriptString} }`)(evalArgv, evalOption, evalScriptPath, (0, _nodePath.dirname)(evalScriptPath), require("node:module").createRequire(evalScriptPath));
exports.evalScript = evalScript;
const stepper = (0, _time.createStepper)();
const logAuto = (...args) => console.log(...1 === args.length && (0, _check.isObjectAlike)(args[0]) ? [ JSON.stringify(args[0], null, 2) ] : args, `(+${(0, _format.time)(stepper())})`);
exports.logAuto = logAuto;
exports.sharedOption = (optionData, modeName) => {
  const {tryGet, tryGetFirst, getToggle} = optionData;
  const log = getToggle("quiet") ? () => {} : logAuto;
  const argumentList = tryGet(modeName) || [];
  const inputFile = tryGetFirst("input-file");
  const outputFile = tryGetFirst("output-file");
  (0, _Pid.configurePid)({
    filePid: tryGetFirst("pid-file")
  });
  const autoBuffer = value => Buffer.isBuffer(value) ? value : (0, _check.isObjectAlike)(value) ? JSON.stringify(value, null, 2) + "\n" : `${value}\n`;
  return {
    optionData,
    modeName,
    argumentList,
    log,
    inputFile,
    outputFile,
    outputValueAuto: async value => outputFile ? (0, _File.writeBuffer)(outputFile, autoBuffer(value)) : (0, _Stream.writeBufferToStreamAsync)(process.stdout, autoBuffer(value)),
    outputStream: stream => (0, _Stream.quickRunletFromStream)(stream, outputFile ? (0, _nodeFs.createWriteStream)(outputFile) : process.stdout)
  };
};
exports.sharedMode = async ({optionData, modeName, argumentList, inputFile, outputValueAuto, patchMP = patchModulePath}) => {
  switch (modeName) {
   case "eval":
    {
      await patchMP();
      const result = await evalScript(inputFile ? await (0, _File.readText)(inputFile) : argumentList[0], inputFile || (0, _nodePath.resolve)("__SCRIPT_STRING__"), inputFile ? argumentList : argumentList.slice(1), optionData);
      return void 0 !== result && outputValueAuto(result);
    }
   case "repl":
    await patchMP();
    return (0, _nodeRepl.start)({
      useGlobal: !0
    });
  }
};