var _format = require("../../library/common/format.js");
var _Router = require("../../library/node/server/Responder/Router.js");
var _Proxy = require("../../library/node/server/Responder/Proxy.js");
exports.configure = ({targetOrigin, isSetXForward = !1, timeout, log}) => {
  const responderHTTPRequestProxy = (0, _Proxy.createResponderHTTPRequestProxy)({
    timeout,
    getProxyConfig: store => {
      const {request: {url, method, headers, socket: {remoteAddress}}} = store;
      const {href: proxyUrl, host} = new URL(url, targetOrigin);
      log(`[PROXY] ${proxyUrl}`);
      return {
        proxyUrl,
        method,
        headers: {
          ...headers,
          host,
          ...isSetXForward && {
            "x-real-ip": remoteAddress,
            "x-forwarded-for": remoteAddress,
            "x-forwarded-host": headers.host || "",
            "x-forwarded-proto": "http"
          }
        }
      };
    }
  });
  return {
    routeConfigList: [ [ [ "/", "/*" ], Object.keys(_Router.METHOD_MAP), responderHTTPRequestProxy ] ],
    isAddFavicon: !1,
    title: "ServerHttpRequestProxy",
    extraInfo: {
      targetOrigin,
      isSetXForward,
      timeout: (0, _format.time)(timeout)
    }
  };
};