exports.isString = value => "string" == typeof value;
exports.isBoolean = value => "boolean" == typeof value;
exports.isTruthy = value => Boolean(value);
exports.isNumber = value => "number" == typeof value;
exports.isInteger = Number.isInteger;
exports.isRegExp = value => value instanceof RegExp;
exports.isArrayBuffer = value => value instanceof ArrayBuffer;
const isObjectAlike = value => {
  const type = typeof value;
  return "object" === type && null !== value || "function" === type;
};
exports.isObjectAlike = isObjectAlike;
const isBasicObject = value => "object" == typeof value && null !== value && !Array.isArray(value);
exports.isBasicObject = isBasicObject;
exports.isObjectKey = (value, key) => isBasicObject(value) && Object.prototype.hasOwnProperty.call(value, key);
exports.isObjectContain = (value, target) => isBasicObject(value) && Object.entries(target).every((([key, targetValue]) => value[key] === targetValue));
const isBasicArray = exports.isBasicArray = Array.isArray;
exports.isArrayLength = (value, length) => isBasicArray(value) && value.length === length;
exports.isBasicFunction = value => "function" == typeof value;
exports.isPromiseAlike = value => Boolean(value && "function" == typeof value.then);
exports.isOneOf = (value, validList) => validList.includes(value);
exports.isFunctionThrow = func => {
  try {
    return func() && !1;
  } catch (error) {
    return !0;
  }
};
exports.isFunctionThrowAsync = async func => {
  try {
    return await func() && !1;
  } catch (error) {
    return !0;
  }
};
exports.isStrictEqual = (actual, expect) => Object.is(actual, expect);
exports.isStringifyEqual = (actual, expect) => !!Object.is(actual, expect) || !(!isObjectAlike(actual) || !isObjectAlike(expect)) && JSON.stringify(actual) === JSON.stringify(expect);