var _check = require("../check.js");
var _Object = require("../immutable/Object.js");
var _Base = require("./Base64.js");
exports.encode = ({value, mime, paramMap}) => {
  const isPayloadBase64 = !(0, _check.isString)(value);
  const payloadString = (isPayloadBase64 ? _Base.encode : encodeURIComponent)(value);
  return `data:${[ mime, paramMap && String(new URLSearchParams(paramMap)).replace(/&/g, ";"), isPayloadBase64 && "base64" ].filter(Boolean).join(";")},${payloadString}`;
};
exports.decode = (string = "") => {
  const payloadIndex = string.indexOf(",");
  const headerStringList = string.slice(5, payloadIndex).split(";").filter(Boolean);
  const isPayloadBase64 = "base64" === headerStringList[headerStringList.length - 1];
  isPayloadBase64 && headerStringList.pop();
  const mime = headerStringList.length && !headerStringList[0].includes("=") && headerStringList.shift() || void 0;
  const paramMap = 0 === headerStringList.length ? void 0 : (0, _Object.objectFromEntries)(new URLSearchParams(headerStringList.join("&")).entries());
  return {
    value: (isPayloadBase64 ? _Base.decode : decodeURIComponent)(string.slice(payloadIndex + 1)),
    mime,
    paramMap
  };
};