exports.createLoopIndex = (LOOP_INDEX_MAX = 2e9) => {
  const normalize = indexAlike => indexAlike % LOOP_INDEX_MAX;
  const INDEX_GAP = Math.floor(.5 * LOOP_INDEX_MAX);
  return {
    LOOP_INDEX_MAX,
    normalize,
    step: (index, stepCount = 1) => normalize(index + stepCount),
    isReached: (index, targetIndexAlike) => {
      const targetIndex = normalize(targetIndexAlike);
      return !(targetIndex > index || targetIndex < index - INDEX_GAP);
    }
  };
};