const createMapMap = () => {
  const map = new Map;
  return {
    clear: () => {
      map.clear();
    },
    delete: (key0, key1) => {
      const subMap = map.get(key0);
      if (!subMap || !subMap.delete(key1)) return !1;
      0 === subMap.size && map.delete(key0);
      return !0;
    },
    set: (key0, key1, value) => {
      let subMap = map.get(key0);
      void 0 === subMap && map.set(key0, subMap = new Map);
      subMap.set(key1, value);
    },
    get: (key0, key1) => {
      const subMap = map.get(key0);
      return subMap && subMap.get(key1);
    },
    getSet: (key0, key1, createValue) => {
      let subMap = map.get(key0);
      void 0 === subMap && map.set(key0, subMap = new Map);
      let value = subMap.get(key1);
      void 0 === value && subMap.set(key1, value = createValue());
      return value;
    },
    has: (key0, key1) => {
      const subMap = map.get(key0);
      return !!subMap && subMap.has(key1);
    },
    forEach: callback => {
      map.forEach(((subMap, key0) => subMap.forEach(((value, key1) => callback(value, key1, key0)))));
    },
    forEachSubMap: callback => {
      map.forEach(callback);
    },
    forEachOfSubMap: (key0, callback) => {
      const subMap = map.get(key0);
      subMap && subMap.forEach(callback);
    }
  };
};
exports.createMapMap = createMapMap;
exports.getInvertMapMap = (sourceMapMap, targetMapMap = createMapMap()) => {
  sourceMapMap.forEach(((value, key1, key0) => targetMapMap.add(key1, key0, value)));
  return targetMapMap;
};