const createSetMap = () => {
  const map = new Map;
  return {
    clear: () => {
      map.clear();
    },
    delete: (mapKey, setKey) => {
      const set = map.get(mapKey);
      if (!set || !set.delete(setKey)) return !1;
      0 === set.size && map.delete(mapKey);
      return !0;
    },
    add: (mapKey, setKey) => {
      let set = map.get(mapKey);
      void 0 === set && map.set(mapKey, set = new Set);
      set.add(setKey);
    },
    get: (mapKey, setKey) => {
      const set = map.get(mapKey);
      return set && set.get(setKey);
    },
    has: (mapKey, setKey) => {
      const set = map.get(mapKey);
      return !!set && set.has(setKey);
    },
    forEach: callback => {
      map.forEach(((set, mapKey) => set.forEach((setKey => callback(setKey, mapKey)))));
    },
    forEachSet: callback => {
      map.forEach(callback);
    },
    forEachOfSet: (mapKey, callback) => {
      const set = map.get(mapKey);
      set && set.forEach(callback);
    }
  };
};
exports.createSetMap = createSetMap;
exports.getInvertSetMap = (sourceSetMap, targetSetMap = createSetMap()) => {
  sourceSetMap.forEach(((setKey, mapKey) => targetSetMap.add(setKey, mapKey)));
  return targetSetMap;
};