var _Vector = require("./Vector.js");
exports.fromEmpty = () => ({
  min: {
    x: 1 / 0,
    y: 1 / 0
  },
  max: {
    x: -1 / 0,
    y: -1 / 0
  }
});
exports.fromPoint = (a, b) => ({
  min: (0, _Vector.min)(a, b),
  max: (0, _Vector.max)(a, b)
});
exports.fromBoundingRect = ({left, right, top, bottom}) => ({
  min: {
    x: left,
    y: top
  },
  max: {
    x: right,
    y: bottom
  }
});
exports.getCenter = ({min, max}) => ({
  x: .5 * (min.x + max.x),
  y: .5 * (min.y + max.y)
});
exports.getSize = ({min, max}) => ({
  x: max.x - min.x,
  y: max.y - min.y
});
exports.getUnion = (a, b) => ({
  min: (0, _Vector.min)(a.min, b.min),
  max: (0, _Vector.max)(a.max, b.max)
});
exports.getUnionOfList = rectList => rectList.reduce(((o, {min, max}) => {
  o.min.x = Math.min(o.min.x, min.x);
  o.min.y = Math.min(o.min.y, min.y);
  o.max.x = Math.max(o.max.x, max.x);
  o.max.y = Math.max(o.max.y, max.y);
  return o;
}), {
  min: {
    x: 1 / 0,
    y: 1 / 0
  },
  max: {
    x: -1 / 0,
    y: -1 / 0
  }
});
exports.isEmpty = ({min, max}) => max.x <= min.x || max.y <= min.y;
exports.isIntersect = (a, b) => !(a.max.x < b.min.x || a.min.x > b.max.x || a.max.y < b.min.y || a.min.y > b.max.y);
exports.isContain = (a, b) => a.min.x <= b.min.x && a.max.x >= b.max.x && a.min.y <= b.min.y && a.max.y >= b.max.y;
exports.isContainPoint = ({min, max}, {x, y}) => x >= min.x && x <= max.x && y >= min.y && y <= max.y;