exports.arraySet = (array, index, value) => {
  if (array[index] === value) return array;
  const result = [ ...array ];
  result[index] = value;
  return result;
};
exports.arrayDelete = (array, index) => index >= 0 && index <= array.length - 1 ? [ ...array.slice(0, index), ...array.slice(index + 1) ] : array;
exports.arrayInsert = (array, index, value) => [ ...array.slice(0, index), value, ...array.slice(index) ];
const arrayMove = (array, index, fromIndex) => fromIndex === index ? array : fromIndex < index ? [ ...array.slice(0, fromIndex), ...array.slice(fromIndex + 1, index + 1), array[fromIndex], ...array.slice(index + 1) ] : [ ...array.slice(0, index), array[fromIndex], ...array.slice(index, fromIndex), ...array.slice(fromIndex + 1) ];
exports.arrayMove = arrayMove;
exports.arrayPush = (array, value) => [ ...array, value ];
exports.arrayUnshift = (array, value) => [ value, ...array ];
exports.arrayPop = array => {
  if (0 === array.length) return array;
  const result = [ ...array ];
  result.pop();
  return result;
};
exports.arrayShift = array => {
  if (0 === array.length) return array;
  const result = [ ...array ];
  result.shift();
  return result;
};
exports.arrayConcat = (array, concatArray) => concatArray && concatArray.length ? [ ...array, ...concatArray ] : array;
exports.arrayMatchPush = (array, value) => array.includes(value) ? array : [ ...array, value ];
exports.arrayMatchDelete = (array, value) => {
  const index = array.indexOf(value);
  return ~index ? [ ...array.slice(0, index), ...array.slice(index + 1) ] : array;
};
exports.arrayMatchMove = (array, index, value) => {
  const fromIndex = array.indexOf(value);
  return ~fromIndex ? arrayMove(array, index, fromIndex) : array;
};
exports.arrayFindDelete = (array, findFunc) => {
  const index = array.findIndex(findFunc);
  return ~index ? [ ...array.slice(0, index), ...array.slice(index + 1) ] : array;
};
exports.arrayFindMove = (array, findFunc, index) => {
  const fromIndex = array.findIndex(findFunc);
  return ~fromIndex ? arrayMove(array, index, fromIndex) : array;
};
exports.arrayFindSet = (array, findFunc, value) => {
  const index = array.findIndex(findFunc);
  if (!~index || array[index] === value) return array;
  const result = [ ...array ];
  result[index] = value;
  return result;
};
exports.arrayFindSetOrPush = (array, findFunc, value) => {
  const index = array.findIndex(findFunc);
  if (!~index) return [ ...array, value ];
  if (array[index] === value) return array;
  const result = [ ...array ];
  result[index] = value;
  return result;
};
exports.arrayFindOrPush = (array, findFunc, value) => void 0 === array.find(findFunc) ? [ ...array, value ] : array;
exports.arraySplitChunk = (array, chunkLength) => {
  const result = [];
  for (let index = 0, indexMax = array.length; index < indexMax; index += chunkLength) result.push(array.slice(index, index + chunkLength));
  return result;
};