exports.isObjectShallowEqual = (value, target) => {
  if (value === target) return !0;
  const valueKeyList = Object.keys(value);
  const targetKeyList = Object.keys(target);
  if (valueKeyList.length !== targetKeyList.length) return !1;
  for (let index = 0, indexMax = valueKeyList.length; index < indexMax; index++) {
    const valueKey = valueKeyList[index];
    const targetKey = targetKeyList[index];
    if (!Object.prototype.hasOwnProperty.call(target, valueKey) || value[valueKey] !== target[targetKey]) return !1;
  }
  return !0;
};
exports.isArrayShallowEqual = (value, target) => value === target || value.length === target.length && value.every(((v, i) => v === target[i]));
exports.isCompactArrayShallowEqual = (value, target) => {
  if (value === target) return !0;
  if (value.length !== target.length) return !1;
  for (let index = 0, indexMax = value.length; index < indexMax; index++) if (value[index] !== target[index]) return !1;
  return !0;
};