var _tryRequire = require("../../env/tryRequire.js");
var _B = require("../data/B62.js");
var _B62S = require("../data/B62S.js");
const RANDOM_INT = (from, to) => Math.floor(Math.random() * (to - from + 1) + from);
exports.getRandomInt = (a, b = 0) => RANDOM_INT(Math.min(a, b), Math.max(a, b));
const getRandomIntList = (a, b, count) => {
  const from = Math.min(a, b);
  const to = Math.max(a, b);
  const resultList = [];
  for (let index = 0, indexMax = Math.min(count, to - from + 1); index < indexMax; index++) {
    let next = RANDOM_INT(from, to - index);
    let insertIndex = 0;
    for (;insertIndex < resultList.length && !(resultList[insertIndex] > next); ) {
      next++;
      insertIndex++;
    }
    resultList.splice(insertIndex, 0, next);
  }
  return resultList;
};
exports.getRandomIntList = getRandomIntList;
exports.getRandomWithinList = (list, count) => list.length && count >= 0 ? getRandomIntList(0, list.length - 1, count).map((i => list[i])) : [];
exports.getRandomId = (prefix = "") => `${prefix}${Date.now().toString(36)}-${Math.random().toString(36).slice(2, 10)}`;
exports.getRandomId62 = (prefix = "") => `${prefix}${(0, _B.encode)(Date.now())}${(0, _B.encode)(Math.floor(Math.random() * 62 ** 7))}`;
exports.getRandomId62S = (prefix = "") => `${prefix}${(0, _B62S.encode)(Date.now())}${(0, _B.encode)(Math.floor(Math.random() * 62 ** 7))}`;
exports.getRandomArrayBuffer = (() => {
  try {
    const {crypto} = globalThis;
    const getRandomArrayBuffer = byteLength => {
      const arrayBuffer = new ArrayBuffer(byteLength);
      for (let index = 0; index < byteLength; index += 65536) crypto.getRandomValues(new Uint8Array(arrayBuffer, index, Math.min(65536, byteLength - index)));
      return arrayBuffer;
    };
    if (32 === getRandomArrayBuffer(32).byteLength) return getRandomArrayBuffer;
  } catch (error) {}
  try {
    const {randomFillSync} = (0, _tryRequire.tryRequire)("node:crypto");
    const getRandomArrayBuffer = byteLength => {
      const dataView = new DataView(new ArrayBuffer(byteLength));
      randomFillSync(dataView);
      return dataView.buffer;
    };
    if (32 === getRandomArrayBuffer(32).byteLength) return getRandomArrayBuffer;
  } catch (error) {}
  return byteLength => {
    const dataView = new DataView(new ArrayBuffer(byteLength));
    for (let index = 0; index < byteLength; index++) dataView.setUint8(index, RANDOM_INT(0, 255));
    return dataView.buffer;
  };
})();