require("../verify.js");
var _error = require("../error.js");
exports.ASYNC_TASK_PHASE_MAP = {
  IDLE: "idle",
  RUN: "run",
  DONE: "done"
};
const PROMISE = "promise";
const QUERY = "query";
const PLAN_PROMISE = "planPromise";
const OUTPUT = "output";
exports.ASYNC_TASK_KEY_MAP = {
  PLAN: "plan",
  PROMISE: "promise",
  QUERY: "query",
  PLAN_PROMISE: "planPromise",
  OUTPUT: "output"
};
const KEY_RESET = {
  [PLAN_PROMISE]: void 0,
  [QUERY]: void 0,
  [PROMISE]: void 0,
  [OUTPUT]: void 0
};
exports.getAsyncTaskPhase = asyncTask => asyncTask.output ? "done" : asyncTask.promise ? "run" : "idle";
exports.runAsyncTask = asyncTask => {
  const planResult = asyncTask.plan(asyncTask);
  planResult !== asyncTask && Object.assign(asyncTask, planResult);
  asyncTask.promise = (0, _error.catchPromise)(asyncTask.planPromise).then((output => asyncTask.output = output));
  return asyncTask.promise;
};
exports.resetAsyncTask = (asyncTask, extra) => ({
  ...asyncTask,
  ...extra,
  ...KEY_RESET
});