var _time = require("../time.js");
var _AsyncFuncQueue = require("./AsyncFuncQueue.js");
var _AsyncTask = require("./AsyncTask.js");
const {PLAN_PROMISE, OUTPUT} = _AsyncTask.ASYNC_TASK_KEY_MAP;
exports.ASYNC_TASK_QUEUE_KEY_MAP = {
  ..._AsyncTask.ASYNC_TASK_KEY_MAP,
  STATUS: "status"
};
exports.createAsyncTaskQueue = () => {
  const {getLength, getTailPromise, reset, push: pushAsyncFunc} = (0, _AsyncFuncQueue.createAsyncFuncQueue)();
  return {
    getLength,
    getTailPromise,
    reset,
    push: asyncTask => {
      asyncTask.status = {
        pushAt: (0, _time.getTimestamp)(),
        runAt: void 0,
        doneAt: void 0
      };
      return pushAsyncFunc((() => {
        asyncTask.status.runAt = (0, _time.getTimestamp)();
        const promise = (0, _AsyncTask.runAsyncTask)(asyncTask);
        const onTaskDone = () => {
          asyncTask.status.doneAt = (0, _time.getTimestamp)();
        };
        asyncTask[PLAN_PROMISE].then(onTaskDone, onTaskDone);
        return promise;
      }));
    }
  };
};
exports.createFilterStaleAsyncTask = (maxStaleTime, maxDoneAt = (0, _time.getTimestamp)() - Math.abs(maxStaleTime)) => asyncTask => !asyncTask[OUTPUT] || asyncTask.status.doneAt > maxDoneAt;