const DEFAULT_MIME = exports.DEFAULT_MIME = "application/octet-stream";
const BASIC_EXTENSION_MAP = exports.BASIC_EXTENSION_MAP = "application|gzip;gz|json|pdf|wasm|xml|x-7z-compressed;7z|x-tar;tar|zip\naudio|midi;mid|mpeg;mp3|ogg|wav|webm;weba|x-flac;flac\nfont|ttf|otf|woff|woff2\nimage|bmp|gif|jpeg;jpg|png|svg+xml;svg|vnd.microsoft.icon;ico|webp\ntext|css|csv|html;htm|javascript;js;mjs;cjs|plain;txt;text;conf;log;ini|rtf|xml\nvideo|mp4;mp4v;mpg4|mpeg;mpg|webm;mkv|x-flv;flv|x-ms-wmv;wmv|x-msvideo;avi".split("\n").reduce(((o, mimeData) => {
  const [type, ...subDataList] = mimeData.split("|");
  subDataList.forEach((subData => {
    const extList = subData.split(";");
    extList.forEach((ext => {
      o[ext] = `${type}/${extList[0]}`;
    }));
  }));
  return o;
}), {});
const REGEXP_EXTENSION = /\.(\w+)$/;
exports.getMIMETypeFromFileName = fileName => {
  const [, fileExt] = REGEXP_EXTENSION.exec(fileName) || [];
  return fileExt && BASIC_EXTENSION_MAP[fileExt.toLowerCase()] || DEFAULT_MIME;
};