const KEY_HASH_ID = {};
exports.createTupleHasher = (initialId = 0, hashMap = new Map) => {
  let id = initialId;
  const hashList = valueList => {
    const indexMax = valueList.length;
    let index = 0;
    let currentHashMap = hashMap;
    for (;index < indexMax; ) {
      const value = valueList[index];
      let nextHashMap = currentHashMap.get(value);
      if (void 0 === nextHashMap) {
        nextHashMap = new Map;
        currentHashMap.set(value, nextHashMap);
      }
      index++;
      currentHashMap = nextHashMap;
    }
    let hashId = currentHashMap.get(KEY_HASH_ID);
    if (void 0 === hashId) {
      hashId = id;
      currentHashMap.set(KEY_HASH_ID, hashId);
      id++;
    }
    return hashId;
  };
  return {
    clear: () => {
      id = initialId;
      hashMap.clear();
    },
    hash: (...valueList) => hashList(valueList),
    hashList
  };
};