var _nodeZlib = require("node:zlib");
exports.packB64 = stringOrBuffer => Buffer.from(stringOrBuffer).toString("base64");
exports.unpackB64 = b64StringOrBuffer => String(Buffer.from(b64StringOrBuffer, "base64"));
exports.packGz64 = stringOrBuffer => (0, _nodeZlib.gzipSync)(Buffer.from(stringOrBuffer), {
  level: 9
}).toString("base64");
exports.unpackGz64 = gz64StringOrBuffer => String((0, _nodeZlib.gunzipSync)(Buffer.from(gz64StringOrBuffer, "base64")));
exports.packBr64 = stringOrBuffer => (0, _nodeZlib.brotliCompressSync)(Buffer.from(stringOrBuffer), {
  params: {
    [_nodeZlib.constants.BROTLI_PARAM_MODE]: _nodeZlib.constants.BROTLI_MODE_TEXT,
    [_nodeZlib.constants.BROTLI_PARAM_QUALITY]: 11,
    [_nodeZlib.constants.BROTLI_PARAM_SIZE_HINT]: Buffer.byteLength(stringOrBuffer)
  }
}).toString("base64");
exports.unpackBr64 = br64StringOrBuffer => String((0, _nodeZlib.brotliDecompressSync)(Buffer.from(br64StringOrBuffer, "base64")));