var _nodePath = require("node:path");
var _error = require("../../common/error.js");
var _Path = require("./Path.js");
var _Directory = require("./Directory.js");
exports.modifyCopy = async (pathFrom, pathTo, pathStat) => {
  void 0 === pathStat && (pathStat = await (0, _Path.getPathLstat)(pathFrom));
  if (pathStat.isDirectory()) return (0, _Directory.copyDirectory)(pathFrom, pathTo, pathStat);
  await (0, _Directory.createDirectory)((0, _nodePath.dirname)(pathTo));
  await (0, _Path.copyPath)(pathFrom, pathTo, pathStat);
};
exports.modifyCopySync = (pathFrom, pathTo, pathStat) => {
  void 0 === pathStat && (pathStat = (0, _Path.getPathLstatSync)(pathFrom));
  if (pathStat.isDirectory()) return (0, _Directory.copyDirectorySync)(pathFrom, pathTo, pathStat);
  (0, _Directory.createDirectorySync)((0, _nodePath.dirname)(pathTo));
  (0, _Path.copyPathSync)(pathFrom, pathTo, pathStat);
};
exports.modifyRename = async (pathFrom, pathTo, pathStat) => {
  await (0, _Directory.createDirectory)((0, _nodePath.dirname)(pathTo));
  await (0, _Path.renamePath)(pathFrom, pathTo, pathStat);
};
exports.modifyRenameSync = (pathFrom, pathTo, pathStat) => {
  (0, _Directory.createDirectorySync)((0, _nodePath.dirname)(pathTo));
  (0, _Path.renamePathSync)(pathFrom, pathTo, pathStat);
};
const modifyDelete = async (path, pathStat) => {
  void 0 === pathStat && (pathStat = await (0, _Path.getPathLstat)(path));
  if (pathStat.isDirectory()) return (0, _Directory.deleteDirectory)(path, pathStat);
  await (0, _Path.deletePath)(path, pathStat);
};
exports.modifyDelete = modifyDelete;
const modifyDeleteSync = (path, pathStat) => {
  void 0 === pathStat && (pathStat = (0, _Path.getPathLstatSync)(path));
  if (pathStat.isDirectory()) return (0, _Directory.deleteDirectorySync)(path, pathStat);
  (0, _Path.deletePathSync)(path, pathStat);
};
exports.modifyDeleteSync = modifyDeleteSync;
exports.modifyDeleteForce = async (path, pathStat) => (0, _error.withFallbackResultAsync)(void 0, modifyDelete, path, pathStat);
exports.modifyDeleteForceSync = (path, pathStat) => (0, _error.withFallbackResult)(void 0, modifyDeleteSync, path, pathStat);