var _nodePath = require("node:path");
var _Directory = require("../../fs/Directory.js");
var _run = require("../../run.js");
var _archive = require("../Archive/archive.js");
var _npmTar = require("../Archive/npmTar.js");
var _tar = require("../Archive/tar.js");
const PATH_COMPRESS_TAR = "path.compress-tar";
const PATH_EXTRACT_TAR = "path.extract-tar";
const PATH_COMPRESS_AUTO = "path.compress-auto";
const PATH_EXTRACT_AUTO = "path.extract-auto";
exports.ACTION_TYPE = {
  PATH_COMPRESS_TAR: "path.compress-tar",
  PATH_EXTRACT_TAR: "path.extract-tar",
  PATH_COMPRESS_AUTO: "path.compress-auto",
  PATH_EXTRACT_AUTO: "path.extract-auto"
};
exports.ACTION_CORE_MAP = (0, _archive.check)() && {
  [PATH_COMPRESS_TAR]: async (sourceDirectory, outputFile) => {
    await (0, _archive.compressAutoAsync)(sourceDirectory, outputFile);
  },
  [PATH_EXTRACT_TAR]: async (sourceFile, outputPath) => {
    await (0, _archive.extractAutoAsync)(sourceFile, outputPath);
  },
  [PATH_COMPRESS_AUTO]: async (sourceDirectory, outputFile) => {
    await (0, _archive.compressAutoAsync)(sourceDirectory, outputFile);
  },
  [PATH_EXTRACT_AUTO]: async (sourceFile, outputPath) => {
    await (0, _archive.extractAutoAsync)(sourceFile, outputPath);
  }
} || (0, _npmTar.check)() && {
  [PATH_COMPRESS_TAR]: async (sourceDirectory, outputFile) => {
    await (0, _npmTar.compressAsync)(sourceDirectory, outputFile);
  },
  [PATH_EXTRACT_TAR]: async (sourceFile, outputPath) => {
    await (0, _npmTar.extractAsync)(sourceFile, outputPath);
  }
} || (0, _tar.check)() && {
  [PATH_COMPRESS_TAR]: async (sourceDirectory, outputFile) => {
    await (0, _Directory.createDirectory)((0, _nodePath.dirname)(outputFile));
    await (0, _run.run)((0, _tar.extractArgs)(sourceDirectory, outputFile)).promise;
  },
  [PATH_EXTRACT_TAR]: async (sourceFile, outputPath) => {
    await (0, _Directory.createDirectory)(outputPath);
    await (0, _run.run)((0, _tar.extractArgs)(sourceFile, outputPath)).promise;
  }
} || {};