var _nodePath = require("node:path");
var _Directory = require("../../fs/Directory.js");
var _FsPack = require("../FsPack.js");
var _function = require("./function.js");
exports.REGEXP_FSP = /\.(?:fsp|fsp\.gz|fsp\.br)$/;
const compressFspAsync = async (sourceDirectory, outputFile) => {
  const fsPack = await (0, _FsPack.initFsPack)({
    packPath: outputFile,
    packRoot: sourceDirectory
  });
  await (0, _FsPack.appendFromPath)(fsPack, sourceDirectory);
  await (0, _FsPack.saveFsPack)(fsPack);
};
exports.compressFspAsync = compressFspAsync;
const extractFspAsync = async (sourceFile, outputPath) => {
  const fsPack = await (0, _FsPack.loadFsPack)({
    packPath: sourceFile
  });
  await (0, _FsPack.unpackToPath)(fsPack, outputPath);
};
exports.extractFspAsync = extractFspAsync;
const compressFspGzBrAsync = async (sourceDirectory, outputFile, pathTemp) => (0, _Directory.withTempDirectory)((async pathTemp => {
  await compressFspAsync(sourceDirectory, (0, _nodePath.resolve)(pathTemp, "archive.fsp"));
  await (0, _function.compressGzBrFileAsync)((0, _nodePath.resolve)(pathTemp, "archive.fsp"), outputFile);
}), pathTemp);
exports.compressFspGzBrAsync = compressFspGzBrAsync;
const extractFspGzBrAsync = async (sourceFile, outputPath, pathTemp) => (0, _Directory.withTempDirectory)((async pathTemp => {
  await (0, _function.extractGzBrFileAsync)(sourceFile, (0, _nodePath.resolve)(pathTemp, "archive.fsp"));
  await extractFspAsync((0, _nodePath.resolve)(pathTemp, "archive.fsp"), outputPath);
}), pathTemp);
exports.extractFspGzBrAsync = extractFspGzBrAsync;
exports.compressAsync = async (sourceDirectory, outputFile, pathTemp) => (_function.REGEXP_GZBR.test(outputFile) ? compressFspGzBrAsync : compressFspAsync)(sourceDirectory, outputFile, pathTemp);
exports.extractAsync = async (sourceFile, outputPath, pathTemp) => (_function.REGEXP_GZBR.test(sourceFile) ? extractFspGzBrAsync : extractFspAsync)(sourceFile, outputPath, pathTemp);