var _nodePath = require("node:path");
var _nodeZlib = require("node:zlib");
var _nodeFs = require("node:fs");
var _tryRequire = require("../../../env/tryRequire.js");
var _Stream = require("../../data/Stream.js");
var _npm = require("../Software/npm.js");
var _function = require("./function.js");
exports.REGEXP_NPM_TAR = /\.(?:tar|tgz|tar\.gz|tbr|tar\.br)$/;
let cacheNpmTar;
const getNpmTar = () => {
  void 0 === cacheNpmTar && (cacheNpmTar = (0, _tryRequire.tryRequire)((0, _npm.fromNpmNodeModules)("tar")) || null);
  return cacheNpmTar;
};
exports.getNpmTar = getNpmTar;
exports.check = () => Boolean(getNpmTar());
exports.verify = () => {
  const npmTar = getNpmTar();
  if (!npmTar) throw new Error('expect "npm/node_modules/tar"');
  return npmTar;
};
const createCompressStream = (sourceDirectory, option = {
  gzip: !0
}, nameList = [ "./" ]) => {
  sourceDirectory = (0, _nodePath.resolve)(sourceDirectory);
  nameList.forEach(((name, index) => name.startsWith("@") && (nameList[index] = `./${name}`)));
  return getNpmTar().create({
    cwd: sourceDirectory,
    ...option
  }, nameList);
};
exports.createCompressStream = createCompressStream;
const createExtractStream = (outputPath, option) => {
  outputPath = (0, _nodePath.resolve)(outputPath);
  return getNpmTar().extract({
    cwd: outputPath,
    ...option
  });
};
exports.createExtractStream = createExtractStream;
exports.compressAsync = async (sourceDirectory, outputFile) => _Stream.quickRunletFromStream.apply(null, [ createCompressStream(sourceDirectory, {
  gzip: _function.REGEXP_TGZ.test(outputFile)
}, await _nodeFs.promises.readdir(sourceDirectory)), _function.REGEXP_TBR.test(outputFile) && (0, _nodeZlib.createBrotliCompress)(), (0, _nodeFs.createWriteStream)((0, _nodePath.resolve)(outputFile)) ].filter(Boolean));
exports.extractAsync = async (sourceFile, outputPath) => _Stream.quickRunletFromStream.apply(null, [ (0, _nodeFs.createReadStream)((0, _nodePath.resolve)(sourceFile)), _function.REGEXP_TBR.test(sourceFile) && (0, _nodeZlib.createBrotliDecompress)(), createExtractStream(outputPath) ].filter(Boolean));
const REGEXP_PACKAGE_JSON = /^[^/]+\/package\.json$/;
exports.extractPackageJSON = async sourceFile => {
  const chunkList = [];
  await getNpmTar().list({
    file: sourceFile,
    onentry: entry => {
      REGEXP_PACKAGE_JSON.test(entry.path) && entry.on("data", (chunk => chunkList.push(chunk)));
    }
  });
  if (!chunkList.length) throw new Error(`expect "${REGEXP_PACKAGE_JSON}" in ".tgz"`);
  return JSON.parse(String(Buffer.concat(chunkList)));
};