var _Exot = require("../../common/module/Exot.js");
var _Logger = require("./Logger.js");
const prefixTime = ({add, ...loggerExot}) => ({
  ...loggerExot,
  add: (...args) => add((new Date).toISOString(), ...args)
});
exports.configureLog = ({pathLogDirectory, logFilePrefix = ""} = {}) => ({
  loggerExot: prefixTime(pathLogDirectory ? (0, _Logger.createLoggerExot)({
    pathLogDirectory,
    getLogFileName: () => `${logFilePrefix}${(new Date).toISOString().replace(/\W/g, "-")}.log`,
    flags: "a"
  }) : (0, _Exot.createDummyExot)({
    idPrefix: "log-",
    add: console.log,
    save: () => {},
    split: () => {}
  }))
});