var _nodePath = require("node:path");
var _PackageJSON = require("../../common/module/PackageJSON.js");
var _File = require("../fs/File.js");
var _Directory = require("../fs/Directory.js");
const toPackageJSONPath = (path = process.cwd()) => (0, _nodePath.resolve)(...[ path, path.endsWith("package.json") ? "" : "package.json" ].filter(Boolean));
exports.toPackageJSONPath = toPackageJSONPath;
const toPackageRootPath = (path = process.cwd()) => (0, _nodePath.resolve)(...[ path, path.endsWith("package.json") ? ".." : "" ].filter(Boolean));
exports.toPackageRootPath = toPackageRootPath;
const writePackageJSON = async (path, packageJSON, isSortKey = !1) => (0, _File.writeText)(path, (0, _PackageJSON.packPackageJSON)(isSortKey ? (0, _PackageJSON.sortPackageJSON)(packageJSON) : packageJSON));
exports.writePackageJSON = writePackageJSON;
exports.editPackageJSON = async (editFunc, pathFrom, pathTo) => (0, _File.editText)((async string => {
  let packageJSON = JSON.parse(string);
  packageJSON = await editFunc(packageJSON);
  return (0, _PackageJSON.packPackageJSON)(packageJSON);
}), pathFrom, pathTo);
const loadPackageInfo = async path => {
  const packageJSONPath = toPackageJSONPath(path);
  return (0, _PackageJSON.toPackageInfo)({
    packageJSON: await (0, _File.readJSON)(packageJSONPath),
    packageJSONPath,
    packageRootPath: toPackageRootPath(packageJSONPath)
  });
};
exports.loadPackageInfo = loadPackageInfo;
const loadPackageInfoList = async pathRoot => {
  const pathPackageJSONList = (await (0, _Directory.getFileList)(pathRoot)).filter((path => "package.json" === (0, _nodePath.basename)(path)));
  const packageInfoList = [];
  for (const pathPackageJSON of pathPackageJSONList) packageInfoList.push(await loadPackageInfo(pathPackageJSON));
  return packageInfoList;
};
exports.loadPackageInfoList = loadPackageInfoList;
exports.loadPackageCombo = async pathRoot => {
  const packageInfoList = await loadPackageInfoList(pathRoot);
  const {dependencyMap, dependencyInfoMap, duplicateInfoList} = packageInfoList.reduce(((o, packageInfo) => (0, _PackageJSON.collectDependency)(packageInfo, o)), {});
  return {
    packageInfoList,
    dependencyMap,
    dependencyInfoMap,
    duplicateInfoList
  };
};
exports.savePackageInfo = async ({packageJSON, packageJSONPath, isSortKey = !1}) => writePackageJSON(packageJSONPath, packageJSON, isSortKey);