var _tryRequire = require("../../env/tryRequire.js");
var _check = require("../../common/check.js");
const DENY_ALL = () => !1;
const ALLOW_ALL = () => !0;
exports.configurePermission = async ({permissionType, permissionFunc, permissionFile, loggerExot}) => {
  let configurePermissionFunc;
  switch (permissionType) {
   case "deny":
    loggerExot.add("use permission: deny-all");
    return {
      checkPermission: DENY_ALL
    };
   case "allow":
    loggerExot.add("use permission: allow-all");
    return {
      checkPermission: ALLOW_ALL
    };
   case "func":
    configurePermissionFunc = permissionFunc;
    if (!(0, _check.isBasicFunction)(configurePermissionFunc)) throw new Error("invalid permissionFunc");
    loggerExot.add("use permissionFunc");
    break;
   case "file":
    configurePermissionFunc = ((0, _tryRequire.tryRequire)(permissionFile) || {
      configurePermission: null
    }).configurePermission;
    if (!(0, _check.isBasicFunction)(configurePermissionFunc)) throw new Error(`failed to load permissionFile: ${permissionFile}`);
    loggerExot.add("use permissionFile");
    break;
   default:
    throw new Error(`invalid permissionType: ${permissionType}`);
  }
  const permissionPack = await configurePermissionFunc({
    loggerExot
  });
  if (!(0, _check.isBasicFunction)(permissionPack.checkPermission)) throw new Error("expect permissionPack.checkPermission to be function");
  return permissionPack;
};