var _nodePath = require("node:path");
var _error = require("../../common/error.js");
var _File = require("../fs/File.js");
var _Directory = require("../fs/Directory.js");
var _Path = require("../fs/Path.js");
var _ExitListener = require("../system/ExitListener.js");
var _Process = require("../system/Process.js");
exports.configurePid = ({filePid, shouldIgnoreExistPid = !1} = {}) => {
  if (filePid) {
    !shouldIgnoreExistPid && (0, _error.catchSync)((() => {
      const existingPid = Number((0, _File.readTextSync)(filePid).trim());
      if (existingPid && (0, _Process.isPidExist)(existingPid)) {
        console.warn(`[Pid] get existing pid: ${existingPid}, exit process...`);
        process.exit(-1);
      }
    }));
    (0, _Directory.createDirectorySync)((0, _nodePath.dirname)(filePid));
    (0, _File.writeTextSync)(filePid, `${process.pid}`);
    (0, _ExitListener.addExitListenerSync)((exitState => {
      (0, _error.catchSync)(_Path.deletePathSync, filePid);
    }));
  }
};