var _nodePath = require("node:path");
var _nodeV = require("node:v8");
var _random = require("../../common/math/random.js");
var _File = require("../fs/File.js");
var _Directory = require("../fs/Directory.js");
const getV8Extra = () => ({
  date: (new Date).toISOString(),
  cachedDataVersionTag: (0, _nodeV.cachedDataVersionTag)(),
  heapSpaceStatistics: (0, _nodeV.getHeapSpaceStatistics)(),
  heapStatistics: (0, _nodeV.getHeapStatistics)(),
  heapCodeStatistics: (0, _nodeV.getHeapCodeStatistics)()
});
exports.getV8Extra = getV8Extra;
exports.getV8HeapSnapshotReadableStream = _nodeV.getHeapSnapshot;
const writeV8HeapSnapshot = exports.writeV8HeapSnapshot = _nodeV.writeHeapSnapshot;
const dumpSync = path => {
  (0, _Directory.createDirectorySync)(path);
  const tag = (0, _random.getRandomId)();
  writeV8HeapSnapshot((0, _nodePath.resolve)(path, `runtime-dump-${tag}.heapsnapshot`));
  (0, _File.writeJSONSync)((0, _nodePath.resolve)(path, `runtime-dump-${tag}.extra.json`), getV8Extra());
};
exports.dumpSync = dumpSync;
exports.setupSIGUSR2 = outputPath => {
  outputPath = (0, _nodePath.resolve)(outputPath);
  const listener = () => dumpSync(outputPath);
  process.on("SIGUSR2", listener);
  return () => process.off("SIGUSR2", listener);
};