var _B62S = require("../../../common/data/B62S.js");
var _random = require("../../../common/math/random.js");
var _run = require("../../run.js");
var _function = require("../function.js");
const {getArgs, setArgs, check, verify} = (0, _function.createArgListPack)((() => (0, _function.probeSync)([ "bash", "--version" ], "GNU bash") ? [ "bash" ] : void 0), 'expect "bash" in PATH');
exports.verify = verify;
exports.check = check;
exports.setArgs = setArgs;
exports.getArgs = getArgs;
exports.runBash = (argList = [], option) => (0, _run.run)([ ...verify(), ...argList ], option);
exports.runBashSync = (argList = [], option) => (0, _run.runSync)([ ...verify(), ...argList ], option);
exports.runBashStdout = (argList = [], option) => (0, _run.runStdout)([ ...verify(), ...argList ], option);
exports.runBashStdoutSync = (argList = [], option) => (0, _run.runStdoutSync)([ ...verify(), ...argList ], option);
exports.runBashCommand = (commandList = [], option) => (0, _run.runStdout)([ ...verify(), "-ec", joinCommand(commonCommandList(commandList)) ], option);
exports.runBashCommandSync = (commandList = [], option) => (0, _run.runSync)([ ...verify(), "-ec", joinCommand(commonCommandList(commandList)) ], option);
exports.commonBashArgList = commandList => [ "bash", "-ec", joinCommand(commandList) ];
const joinCommand = commandList => commandList.filter(Boolean).join("\n");
exports.joinCommand = joinCommand;
const commonCommandList = commandList => [ "shopt -s dotglob nullglob", "set -ex", ...commandList ];
exports.commonCommandList = commonCommandList;
exports.subShellCommandList = commandList => [ "( # ".padEnd(16, "="), ...commandList, ") # ".padEnd(16, "=") ];
const toHeredocNoMagic = (string = "", extraPipeCommand = "", EOM = (0, _random.getRandomId62S)(`EOM-${(0, _B62S.encode)(string.length)}-`)) => `<< '${EOM}' ${extraPipeCommand}\n${string}\n${EOM}`;
exports.toHeredocNoMagic = toHeredocNoMagic;
exports.catStringToVarCommand = string => `$(cat ${toHeredocNoMagic(string)}\n)`;
exports.catStringToFileCommand = (string, pathFile) => `cat ${toHeredocNoMagic(string, `> "${pathFile}"`)}`;
exports.gitFetchBranchCommandList = (branchName, branchCommitHash = "HEAD", remoteName = "origin") => [ `git fetch --force --no-tags "${remoteName}" "${branchName}:remotes/${remoteName}/${branchName}"`, `git checkout --force -B "${branchName}"`, `git reset --hard "${branchCommitHash}"` ];
exports.gitCleanUpCommandList = () => [ "git gc --auto", "( git branch -D $(git branch | grep -v \\* | xargs) 2> /dev/null || true )" ];
exports.commonSourceProfileCommandList = () => [ "[[ -f /etc/profile ]] && source /etc/profile", "[[ -f ~/.profile ]] && source ~/.profile", "[[ -f ~/.bash_profile ]] && source ~/.bash_profile" ];