var _run = require("../../run.js");
var _function = require("../function.js");
const {getArgs, setArgs, check, verify} = (0, _function.createArgListPack)((() => (0, _function.probeSync)([ "git", "--version" ], "git version") ? [ "git" ] : void 0), 'expect "git" in PATH');
exports.verify = verify;
exports.check = check;
exports.setArgs = setArgs;
exports.getArgs = getArgs;
exports.runGit = (argList = [], option) => (0, _run.run)([ ...verify(), ...argList ], option);
exports.runGitSync = (argList = [], option) => (0, _run.runSync)([ ...verify(), ...argList ], option);
exports.runGitStdout = (argList = [], option) => (0, _run.runStdout)([ ...verify(), ...argList ], option);
exports.runGitStdoutSync = (argList = [], option) => (0, _run.runStdoutSync)([ ...verify(), ...argList ], option);
const gitString = (...args) => (0, _function.spawnString)([ ...verify(), ...args ]);
const squeeze = string => string.replace(/\s/g, "");
exports.getGitBranch = () => squeeze(gitString("symbolic-ref", "--short", "HEAD") || `detached-HEAD/${gitString("rev-parse", "--short", "HEAD")}`);
exports.getGitCommitHash = (revisionRange = "HEAD") => squeeze(gitString("log", "-1", "--format=%H", revisionRange));
exports.getGitCommitMessage = (revisionRange = "HEAD") => gitString("log", "-1", "--format=%B", revisionRange);