var _nodeChild_process = require("node:child_process");
const spawnString = ([command, ...argList]) => String((0, _nodeChild_process.spawnSync)(command, argList).stdout || "");
exports.spawnString = spawnString;
exports.probeSync = (argList = [], expect) => spawnString(argList).includes(expect);
exports.createArgListPack = (getArgList, message) => {
  let args;
  return {
    getArgs: () => args,
    setArgs: (...newArgs) => args = newArgs,
    check: () => {
      void 0 === args && (args = getArgList());
      return Boolean(args);
    },
    verify: () => {
      void 0 === args && (args = getArgList());
      if (!args) throw new Error(message);
      return args;
    }
  };
};