var _Auth = require("../../../module/Auth.js");
var _Router = require("../../Responder/Router.js");
var _Send = require("../../Responder/Send.js");
var _function = require("../../function.js");
const PERMISSION_CHECK_ACTION_JSON = exports.PERMISSION_CHECK_ACTION_JSON = "permission:check:action-json";
const PERMISSION_CHECK_ACTION_JSON_PUBLIC = exports.PERMISSION_CHECK_ACTION_JSON_PUBLIC = "permission:check:action-json-public";
exports.setup = async ({name = "feature:action-json", loggerExot, routePrefix = "", featureAuth: {authPack: {authMode}, createResponderCheckAuth}, featurePermission: {permissionPack: {checkPermission = (type, payload) => !0}}, actionMap = {}, actionMapPublic = {}, URL_ACTION_JSON = `${routePrefix}/action-json`, URL_ACTION_JSON_ABBR = `${routePrefix}/ajson`, URL_ACTION_JSON_PUBLIC = `${routePrefix}/action-json-public`, URL_ACTION_JSON_PUBLIC_ABBR = `${routePrefix}/AJSON`, IS_SKIP_AUTH = authMode === _Auth.AUTH_SKIP}) => {
  const routeList = [ [ [ `${URL_ACTION_JSON}/*`, `${URL_ACTION_JSON_ABBR}/*` ], "POST", createResponderCheckAuth({
    responderNext: async store => {
      const actionType = decodeURIComponent((0, _Router.getRouteParamAny)(store) || "");
      const actionFunc = actionMap[actionType];
      if (!actionFunc) return;
      const actionPayload = await (0, _function.getRequestJSON)(store);
      return IS_SKIP_AUTH || await checkPermission(PERMISSION_CHECK_ACTION_JSON, {
        store,
        actionType,
        actionPayload
      }) ? (0, _Send.responderSendJSON)(store, {
        object: await actionFunc(store, actionPayload)
      }) : void 0;
    }
  }) ], [ [ `${URL_ACTION_JSON_PUBLIC}/*`, `${URL_ACTION_JSON_PUBLIC_ABBR}/*` ], "POST", async store => {
    const actionType = decodeURIComponent((0, _Router.getRouteParamAny)(store) || "");
    const actionFunc = actionMapPublic[actionType];
    if (!actionFunc) return;
    const actionPayload = await (0, _function.getRequestJSON)(store);
    return await checkPermission(PERMISSION_CHECK_ACTION_JSON_PUBLIC, {
      store,
      actionType,
      actionPayload
    }) ? (0, _Send.responderSendJSON)(store, {
      object: await actionFunc(store, actionPayload)
    }) : void 0;
  } ] ];
  return {
    actionMap,
    actionMapPublic,
    URL_ACTION_JSON,
    URL_ACTION_JSON_ABBR,
    URL_ACTION_JSON_PUBLIC,
    URL_ACTION_JSON_PUBLIC_ABBR,
    routeList,
    name
  };
};