var _Auth = require("../../../module/Auth.js");
var _Common = require("../../Responder/Common.js");
var _RateLimit = require("../../Responder/RateLimit.js");
var _function = require("../../function.js");
exports.setup = async ({name = "feature:auth", loggerExot: {add: log}, routePrefix = "", authKey, authSkip = !1, authFile, authFileGroupPath, authFileGroupDefaultTag, authFileGroupKeySuffix, URL_AUTH_CHECK = `${routePrefix}/auth`, URL_AUTH_CHECK_ABBR = `${routePrefix}/a`}) => {
  const authPack = await (0, _Auth.configureAuth)({
    authKey,
    log,
    authSkip,
    authFile,
    authFileGroupPath,
    authFileGroupDefaultTag,
    authFileGroupKeySuffix
  });
  const createResponderCheckAuth = ({responderNext, responderDeny}) => (0, _RateLimit.createResponderCheckRateLimit)({
    checkFunc: async store => {
      const authToken = await authPack.checkAuth((0, _function.getRequestParam)(store, authPack.authKey));
      store.setState({
        authToken
      });
      return !0;
    },
    responderNext,
    responderDeny
  });
  const routeList = [ [ [ URL_AUTH_CHECK, URL_AUTH_CHECK_ABBR ], "HEAD", createResponderCheckAuth({
    responderNext: store => (0, _Common.responderEndWithStatusCode)(store, {
      statusCode: 200
    })
  }) ] ];
  return {
    authPack,
    createResponderCheckAuth,
    URL_AUTH_CHECK,
    URL_AUTH_CHECK_ABBR,
    routeList,
    name
  };
};