var _MIME = require("../../../../common/module/MIME.js");
var _Send = require("../../Responder/Send.js");
var _Auth = require("../../../module/Auth.js");
var _path = require("../../../module/ActionJSON/path.js");
var _pathExtraArchive = require("../../../module/ActionJSON/pathExtraArchive.js");
var _status = require("../../../module/ActionJSON/status.js");
var _main = require("./HTML/main.js");
exports.setup = async ({name = "feature:explorer", loggerExot, routePrefix = "", featureAuth: {authPack: {authMode}, URL_AUTH_CHECK_ABBR}, featureActionJSON: {actionMap, URL_ACTION_JSON_ABBR}, featureFile: {IS_READ_ONLY, URL_FILE_SERVE_ABBR, URL_FILE_UPLOAD}, URL_HTML = `${routePrefix}/explorer`, IS_SKIP_AUTH = authMode === _Auth.AUTH_SKIP}) => {
  const ACTION_TYPE = {
    ..._path.ACTION_TYPE,
    STATUS_SERVER_COMMON: _status.ACTION_TYPE.STATUS_SERVER_COMMON
  };
  for (const actionType of Object.values(ACTION_TYPE)) if (!actionMap[actionType]) throw new Error(`expect ActionJSON provide: ${actionType}`);
  const IS_EXTRA_TAR = Boolean(actionMap[_pathExtraArchive.ACTION_TYPE.PATH_COMPRESS_TAR]);
  const IS_EXTRA_AUTO = Boolean(actionMap[_pathExtraArchive.ACTION_TYPE.PATH_COMPRESS_AUTO]);
  IS_EXTRA_TAR && Object.assign(ACTION_TYPE, {
    PATH_COMPRESS_TAR: _pathExtraArchive.ACTION_TYPE.PATH_COMPRESS_TAR,
    PATH_EXTRACT_TAR: _pathExtraArchive.ACTION_TYPE.PATH_EXTRACT_TAR
  });
  IS_EXTRA_AUTO && Object.assign(ACTION_TYPE, {
    PATH_COMPRESS_AUTO: _pathExtraArchive.ACTION_TYPE.PATH_COMPRESS_AUTO,
    PATH_EXTRACT_AUTO: _pathExtraArchive.ACTION_TYPE.PATH_EXTRACT_AUTO
  });
  const HTMLBufferData = (0, _Send.prepareBufferData)(Buffer.from((0, _main.getHTML)({
    URL_AUTH_CHECK_ABBR,
    URL_ACTION_JSON_ABBR,
    URL_FILE_SERVE_ABBR,
    URL_FILE_UPLOAD,
    IS_SKIP_AUTH,
    IS_READ_ONLY,
    IS_EXTRA_TAR,
    IS_EXTRA_AUTO,
    ACTION_TYPE
  })), _MIME.BASIC_EXTENSION_MAP.html);
  const routeList = [ [ URL_HTML, "GET", store => (0, _Send.responderSendBufferCompress)(store, HTMLBufferData) ] ].filter(Boolean);
  return {
    URL_HTML,
    routeList,
    name
  };
};