var _Path = require("../../../fs/Path.js");
var _Common = require("../../Responder/Common.js");
var _ServeStatic = require("../../Responder/ServeStatic.js");
var _FileChunkUpload = require("../../../module/FileChunkUpload.js");
var _function = require("../../function.js");
exports.createResponderServeFile = ({rootPath, responderFallback, extraOption}) => {
  const getPath = (0, _Path.createPathPrefixLock)(rootPath);
  const responderServeStatic = (0, _ServeStatic.createResponderServeStatic)({
    expireTime: 1e4,
    ...extraOption
  });
  return responderFallback ? (store, relativePath) => responderServeStatic(store, getPath(relativePath)).catch((error => responderFallback(store, {
    error,
    relativePath
  }))) : (store, relativePath) => responderServeStatic(store, getPath(relativePath));
};
exports.createResponderFileChunkUpload = async ({rootPath, mergePath, loggerExot}) => {
  const fileChunkUpload = await (0, _FileChunkUpload.createOnFileChunkUpload)({
    rootPath,
    mergePath,
    onError: error => {
      loggerExot.add(`[ERROR][FileChunkUpload] ${error}`);
      console.error(error);
    }
  });
  return async (store, extraFileUploadOption = {}) => {
    await fileChunkUpload({
      bufferPacket: await (0, _function.getRequestBuffer)(store),
      ...extraFileUploadOption
    });
    return (0, _Common.responderEndWithStatusCode)(store, {
      statusCode: 200
    });
  };
};