var _nodeNet = require("node:net");
var _nodeTls = require("node:tls");
exports.createTCPProxyListener = ({isSecure = !1, getTargetOption = socket => ({
  hostname: "127.0.0.1",
  port: 80
})}) => async socket => {
  let preConnectDataList = [];
  const preConnectListener = data => preConnectDataList.push(data);
  socket.on("data", preConnectListener);
  const socketEndListener = () => targetSocket.destroy();
  socket.on("error", socketEndListener);
  socket.on("close", socketEndListener);
  const option = await getTargetOption(socket);
  void 0 === option.host && (option.host = option.hostname);
  const targetSocket = (isSecure ? _nodeTls.connect : _nodeNet.connect)(option, (() => {
    for (const data of preConnectDataList) targetSocket.write(data);
    preConnectDataList = null;
    socket.off("data", preConnectListener);
    socket.on("data", (data => targetSocket.write(data)));
  }));
  const targetSocketEndListener = () => socket.destroy();
  targetSocket.on("error", targetSocketEndListener);
  targetSocket.on("close", targetSocketEndListener);
  targetSocket.on("data", (data => socket.write(data)));
};