var _nodeCrypto = require("node:crypto");
var _nodeBuffer = require("node:buffer");
var _Buffer = require("../../data/Buffer.js");
exports.FRAME_CONFIG = {
  COMPLETE: [ 8, 15 ],
  FIRST: [ 0, 15 ],
  MORE: [ 0, 0 ],
  LAST: [ 8, 0 ]
};
exports.OPCODE_TYPE = {
  CONTINUATION: 0,
  TEXT: 1,
  BINARY: 2,
  CLOSE: 8,
  PING: 9,
  PONG: 10
};
exports.WEBSOCKET_VERSION = 13;
exports.getRequestKey = () => (0, _nodeCrypto.randomBytes)(16).toString("base64");
exports.getRespondKey = requestKey => (0, _Buffer.calcHash)(`${requestKey}258EAFA5-E914-47DA-95CA-C5AB0DC85B11`);
exports.BUFFER_MAX_LENGTH = _nodeBuffer.constants.MAX_LENGTH;
exports.applyMaskQuadletBufferInPlace = (buffer, maskQuadletBuffer, indexOffset = 0) => {
  for (let index = 0, indexMax = buffer.length - indexOffset; index < indexMax; index++) buffer[index + indexOffset] ^= maskQuadletBuffer[3 & index];
};
exports.packProtocolList = array => array.join(",");
exports.parseProtocolString = string => (string || "").split(/, */);