const DEFAULT_OPEN_COMMAND_LIST_MAP = {
  linux: [ "xdg-open" ],
  win32: [ "rundll32.exe", "url.dll,OpenURL" ],
  darwin: [ "open" ],
  android: [ "termux-open" ]
};
exports.getDefaultOpenCommandList = () => {
  const defaultOpenCommandList = DEFAULT_OPEN_COMMAND_LIST_MAP[process.platform];
  if (!defaultOpenCommandList) throw new Error(`unsupported platform: ${process.platform}`);
  return defaultOpenCommandList;
};