var _nodeChild_process = require("node:child_process");
var _nodePath = require("node:path");
var _run = require("../run.js");
const configureLinux = () => [ "which", stdoutString => stdoutString.trim() ];
const CONFIGURE_MAP = {
  linux: configureLinux,
  win32: (extList = (process.env.PATHEXT || ".EXE;.BAT;.CMD").toUpperCase().split(";")) => [ "where.exe", stdoutString => stdoutString.split("\r\n").find((path => extList.includes(path.slice(path.lastIndexOf(".")).toUpperCase()))) || "" ],
  darwin: configureLinux,
  android: configureLinux
};
let cacheConfigure;
const configureCached = () => {
  if (void 0 === cacheConfigure) {
    const configure = CONFIGURE_MAP[process.platform];
    if (!configure) throw new Error(`unsupported platform: ${process.platform}`);
    cacheConfigure = configure();
  }
  return cacheConfigure;
};
const resolveCommandName = (commandName, cwd) => {
  const [checkCommand, processFunc] = configureCached();
  return processFunc(String((0, _nodeChild_process.spawnSync)(checkCommand, [ commandName ], {
    cwd
  }).stdout || ""));
};
exports.resolveCommandName = resolveCommandName;
const resolveCommandNameAsync = async (commandName, cwd) => {
  const [checkCommand, processFunc] = configureCached();
  return processFunc(String(await (0, _run.runStdout)([ checkCommand, commandName ], {
    cwd
  }).catch((() => ""))));
};
exports.resolveCommandNameAsync = resolveCommandNameAsync;
exports.resolveCommand = (command, cwd) => REGEXP_PATH_SEP.test(command) ? (0, _nodePath.resolve)(cwd || "", command) : resolveCommandName(command, cwd);
exports.resolveCommandAsync = async (command, cwd) => REGEXP_PATH_SEP.test(command) ? (0, _nodePath.resolve)(cwd || "", command) : resolveCommandNameAsync(command, cwd);
const REGEXP_PATH_SEP = /[\\/]/;