import { getEndianness } from "../../env/function.js";
const uint32FromRgba = "little" === getEndianness() ? (R, G, B, A) => R + (G << 8) + (B << 16) + (A << 24) : (R, G, B, A) => A + (B << 8) + (G << 16) + (R << 24);
const rgbaFromUint32 = "little" === getEndianness() ? value => ({
  r: 255 & value,
  g: (65280 & value) >> 8,
  b: (16711680 & value) >> 16,
  a: (4278190080 & value) >> 24
}) : value => ({
  a: 255 & value,
  b: (65280 & value) >> 8,
  g: (16711680 & value) >> 16,
  r: (4278190080 & value) >> 24
});
const toHex2 = number => number.toString(16).padStart(2, "0");
const hexCSSFromRgba = (R, G, B, A) => `#${toHex2(R)}${toHex2(G)}${toHex2(B)}${toHex2(A)}`.toUpperCase();
const hexCSSFromRgb = (R, G, B) => `#${toHex2(R)}${toHex2(G)}${toHex2(B)}`.toUpperCase();
export { uint32FromRgba, rgbaFromUint32, hexCSSFromRgba, hexCSSFromRgb };