import { fromU16String, toU16String } from "../../common/data/ArrayBuffer.js";
import { HEADER_BYTE_SIZE, packArrayBufferHeader } from "../../common/data/ArrayBufferPacket.js";
import { Blob, parseBlobAsArrayBuffer } from "./Blob.js";
const EMPTY_BLOB = new Blob;
const packBlobPacket = (headerU16String, payloadBlob = EMPTY_BLOB) => new Blob([ ...packArrayBufferHeader(fromU16String(headerU16String)), payloadBlob ]);
const parseBlobPacket = async blobPacket => {
  const headerSize = new DataView(await parseBlobAsArrayBuffer(blobPacket.slice(0, HEADER_BYTE_SIZE))).getUint32(0, !1);
  return [ toU16String(await parseBlobAsArrayBuffer(blobPacket.slice(HEADER_BYTE_SIZE, HEADER_BYTE_SIZE + headerSize))), blobPacket.slice(HEADER_BYTE_SIZE + headerSize) ];
};
export { packBlobPacket, parseBlobPacket };