import { getRandomId62S } from "../../common/math/random.js";
import { isObjectContain } from "../../common/check.js";
const {document} = window;
const createKeyCommandHub = ({eventSource = document, isSkipPreventDefault = !1} = {}) => {
  const keyCommandMap = new Map;
  const keyCommandListener = event => keyCommandMap.forEach((keyCommand => {
    const {target, checkMap, callback} = keyCommand;
    if ((!target || target.contains(event.target)) && isObjectContain(event, checkMap)) {
      !isSkipPreventDefault && event.preventDefault();
      callback(event, keyCommand);
    }
  }));
  let isActive = !1;
  return {
    getIsActive: () => isActive,
    start: () => {
      eventSource.addEventListener("keydown", keyCommandListener);
      isActive = !0;
    },
    stop: () => {
      eventSource.removeEventListener("keydown", keyCommandListener);
      isActive = !1;
    },
    addKeyCommand: ({id = getRandomId62S(), target, checkMap, callback}) => {
      keyCommandMap.set(id, {
        id,
        target,
        checkMap,
        callback
      });
      return id;
    },
    deleteKeyCommand: ({id}) => keyCommandMap.delete(id)
  };
};
export { createKeyCommandHub };