import { uploadArrayBufferByChunk } from "../../common/module/ChunkUpload.js";
import { parseBlobAsArrayBuffer } from "../data/Blob.js";
const {isSecureContext} = window;
const uploadFileByChunk = async ({fileBlob, fileSize = fileBlob.size, key, chunkSizeMax, uploadChunk, onProgress}) => uploadArrayBufferByChunk({
  size: fileSize,
  getChunk: async (index, chunkSize) => parseBlobAsArrayBuffer(fileBlob.slice(index, index + chunkSize)),
  key,
  chunkSizeMax,
  isSkipVerifyHash: !isSecureContext,
  uploadChunk,
  onProgress
});
export { uploadFileByChunk };