import { isCompactArrayShallowEqual } from "../../common/immutable/check.js";
const {localStorage} = window;
const createLocalStorageStateStore = ({keyPrefix = "STATE", keyListKey = "@@KEY_LIST", setItem = (key, value) => localStorage.setItem(`${keyPrefix}|${key}`, JSON.stringify(value)), getItem = key => JSON.parse(localStorage.getItem(`${keyPrefix}|${key}`)), removeItem = key => localStorage.removeItem(`${keyPrefix}|${key}`)}) => {
  let persistState = {};
  let persistKeyList = [];
  return {
    save: state => {
      const keyList = Object.keys(state);
      for (const key of keyList) persistState[key] !== state[key] && setItem(key, state[key]);
      for (const key of persistKeyList) !state[key] && removeItem(key);
      isCompactArrayShallowEqual(keyList, persistKeyList) || setItem(keyListKey, keyList);
      persistState = state;
      persistKeyList = keyList;
    },
    load: () => {
      try {
        const loadKeyList = getItem(keyListKey) || [];
        persistState = loadKeyList.reduce(((o, key) => {
          o[key] = getItem(key);
          return o;
        }), {});
        persistKeyList = loadKeyList;
      } catch (error) {}
      return persistState;
    }
  };
};
export { createLocalStorageStateStore };