const compareString = (a, b) => a < b ? -1 : a > b ? 1 : 0;
const compareStringLocale = (a, b) => a.localeCompare(b);
const compareStringWithNumber = (a = "", b = "") => {
  if (a === b) return 0;
  let diffIndex = -1;
  let aCharCode, bCharCode;
  do {
    diffIndex++;
    aCharCode = a.charCodeAt(diffIndex);
    bCharCode = b.charCodeAt(diffIndex);
  } while (aCharCode === bCharCode);
  const isNumberA = isNumberCharCode(aCharCode);
  const isNumberB = isNumberCharCode(bCharCode);
  return isNumberA && (isNumberB || isNumberCharCode(b.charCodeAt(diffIndex - 1))) || isNumberB && (isNumberA || isNumberCharCode(a.charCodeAt(diffIndex - 1))) ? getNumberAtIndex(a, isNumberA ? diffIndex : diffIndex - 1) - getNumberAtIndex(b, isNumberB ? diffIndex : diffIndex - 1) : (aCharCode || 0) - (bCharCode || 0);
};
const isNumberCharCode = charCode => charCode >= 48 && charCode <= 57;
const getNumberAtIndex = (string = "", index) => {
  let indexStart = index - 1;
  let indexEnd = index + 1;
  for (;isNumberCharCode(string.charCodeAt(indexStart)); ) indexStart--;
  for (;isNumberCharCode(string.charCodeAt(indexEnd)); ) indexEnd++;
  return Number(string.slice(indexStart + 1, indexEnd));
};
export { compareString, compareStringLocale, compareStringWithNumber };