const __CHAR_LIST = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");
const B62_ZERO = "0";
const B62_MAX = "Z";
/** @type { (uint: number) => string } */ const encode = uint => {
  if (0 === uint) return "0";
  let string = "";
  for (;uint > 0; ) {
    string = __CHAR_LIST[uint % 62] + string;
    uint = Math.floor(uint / 62);
  }
  return string;
};
const __POW62_LIST = [ 1, 62, 3844, 238328, 14776336, 916132832, 56800235584, 3521614606208, 0xc694446f0100 ];
/** @type { (uintString: string) => number } */ const decode = uintString => {
  let uint = 0;
  const length = uintString.length;
  for (let i = 0; i < length; i++) {
    const charCode = uintString.charCodeAt(i);
    uint += (charCode <= 57 ? charCode - 48 : charCode <= 90 ? charCode - 65 + 36 : charCode - 97 + 10) * __POW62_LIST[length - i - 1];
  }
  return uint;
};
export { B62_ZERO, B62_MAX, encode, decode };