const __CHAR_LIST = "()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_`abcdefghijklmnopqrstuvwxyz{|}~".split("");
const B86_ZERO = "(";
const B86_MAX = "~";
/** @type { (uint: number) => string } */ const encode = uint => {
  if (0 === uint) return "(";
  let string = "";
  for (;uint > 0; ) {
    string = __CHAR_LIST[uint % 86] + string;
    uint = Math.floor(uint / 86);
  }
  return string;
};
const __POW86_LIST = [ 1, 86, 7396, 636056, 54700816, 4704270176, 404567235136, 34792782221696, 0xaa15f068e6100 ];
/** @type { (uintString: string) => number } */ const decode = uintString => {
  let uint = 0;
  const length = uintString.length;
  for (let i = 0; i < length; i++) {
    const charCode = uintString.charCodeAt(i);
    uint += (charCode <= 91 ? charCode - 40 : charCode - 40 - 1) * __POW86_LIST[length - i - 1];
  }
  return uint;
};
export { B86_ZERO, B86_MAX, encode, decode };