import { createInsideOutPromise } from "../function.js";
import { getRandomId62S } from "../math/random.js";
/** @typedef { { value: *, done: boolean } } IterStatus */
/** @typedef { () => IterStatus } IterNextSync */
/** @typedef { () => Promise<IterStatus> } IterNextAsync */
/** @typedef { () => { next: IterNextSync } } IterIteratorSync */
/** @typedef { () => { next: IterNextAsync } } IterIteratorAsync */
/** @typedef { { next: IterNextSync, [ Symbol.iterator ]: IterIteratorSync } } IterIterableSync */
/** @typedef { { next: IterNextAsync, [ Symbol.asyncIterator ]: IterIteratorAsync } } IterIterableAsync */
/** @type { (option: {
 *    iterable?: IterIterableSync | IterIterableAsync,
 *    iterator?: IterIteratorSync | IterIteratorAsync,
 *    next?: IterNextSync | IterNextAsync,
 * }) => IterNextSync | IterNextAsync }  */ const unwrap = ({iterable, iterator = iterable && (iterable[Symbol.asyncIterator] || iterable[Symbol.iterator]).call(iterable), next = iterator && iterator.next.bind(iterator)}) => next
/** @type { (n: IterNextSync) => IterIterableSync }  */;
const wrapSync = next => ({
  next,
  [Symbol.iterator]: () => ({
    next
  })
  /** @type { (n: IterNextAsync) => IterIterableAsync }  */});
const wrapAsync = next => ({
  next,
  [Symbol.asyncIterator]: () => ({
    next
  })
});
const createLockStepAsyncIter = () => {
  let sendIOP = createInsideOutPromise();
  let nextIOP = createInsideOutPromise();
  let sendLock = !1;
  let nextLock = !1;
  let isDone = !1;
  return {
    ...wrapAsync((async () => {
      if (nextLock) throw new Error("double-next");
      nextLock = !0;
      sendIOP.resolve();
      /** @type { IterStatus }  */      const result = await nextIOP.promise;
      !1 === isDone && (nextIOP = createInsideOutPromise());
      nextLock = !1;
      return result;
    })),
    /** @type { (value: *, done: boolean) => Promise<void> } */
    send: async (value, done = !1) => {
      if (sendLock) throw new Error("double-send");
      sendLock = !0;
      await sendIOP.promise;
      isDone = done;
      nextIOP.resolve({
        value,
        done
      });
      !1 === isDone && (sendIOP = createInsideOutPromise());
      sendLock = !1;
    },
    /** @type { (value: *) => void } */
    abort: value => {
      isDone = !0;
      nextIOP.resolve({
        value,
        done: !0
      });
    },
    /** @type { (error: Error) => void } */
    throw: error => {
      isDone = !0;
      nextIOP.reject(error);
    }
  };
};
export { unwrap, wrapSync, wrapAsync, createLockStepAsyncIter };