/** @type { (a: string, b?: number) => number } */
const hashStringToNumber = (string = "", hash = 0) => {
  for (let index = 0, indexMax = string.length; index < indexMax; index++) hash = (hash << 5) - hash + string.charCodeAt(index) >>> 0;
  return hash;
};
/** @type { (v: string) => string } */ const reverseString = string => [ ...string ].reverse().join("")
/** @type { (v: string) => string } */;
const swapObfuscateString = (string = "") => {
  const stringLength = string.length;
  const stringEndIndex = stringLength - 1;
  const indexMax = Math.floor(.5 * stringLength);
  const result = [];
  stringLength % 2 && (result[indexMax] = string.charAt(indexMax));
  for (let index = 0; index < indexMax; index++) {
    const pickIndex = index % 2 ? index : stringEndIndex - index;
    result[index] = string.charAt(pickIndex);
    result[stringEndIndex - index] = string.charAt(stringEndIndex - pickIndex);
  }
  return result.join("");
};
/** @type { (v: vJSON) => vJSON } */ const dupJSON = value => JSON.parse(JSON.stringify(value))
/** @type { (v: string, d:vJSON) => vJSON } */;
const tryParseJSONObject = (text, defaultResult = {}) => {
  try {
    const result = JSON.parse(text);
    if ("object" == typeof result && null !== result) return result;
  } catch (error) {}
  return defaultResult;
};
/** @type { (a: vJSON, b: string[]) => vJSON | undefined } */ const getValueByKeyList = (value, keyList) => {
  for (const key of keyList) {
    if (!value || !Object.prototype.hasOwnProperty.call(value, key)) return;
    value = value[key];
  }
  return value;
};
export { hashStringToNumber, reverseString, swapObfuscateString, dupJSON, tryParseJSONObject, getValueByKeyList };