import { isCompactArrayShallowEqual } from "./check.js";
const transformCache = transformFunc => {
  let cacheResult = null;
  let cacheArgs = null;
  return (...args) => {
    if (!cacheArgs || !isCompactArrayShallowEqual(cacheArgs, args)) {
      cacheResult = transformFunc.apply(null, args);
      cacheArgs = args;
    }
    return cacheResult;
  };
};
export { transformCache };