const roundFloat = value => Math.round(1e4 * value) / 1e4;
const addAbs = (value, add) => Math.sign(value) * Math.max(0, Math.abs(value) + add);
const euclideanModulo = (value, divisor) => (value % divisor + divisor) % divisor;
const clamp = (value, min, max) => Math.max(min, Math.min(max, value));
const smoothstep = (value, min, max) => value <= min ? 0 : value >= max ? 1 : (value = (value - min) / (max - min)) * value * (3 - 2 * value);
const lerp = (from, to, rate) => from + (to - from) * rate;
export { roundFloat, addAbs, euclideanModulo, clamp, smoothstep, lerp };