import { tryRequire } from "../../env/tryRequire.js";
import { encode as encodeB62 } from "../data/B62.js";
import { encode as encodeB62S } from "../data/B62S.js";
const RANDOM_INT = (from, to) => Math.floor(Math.random() * (to - from + 1) + from);
const getRandomInt = (a, b = 0) => RANDOM_INT(Math.min(a, b), Math.max(a, b));
const getRandomIntList = (a, b, count) => {
  const from = Math.min(a, b);
  const to = Math.max(a, b);
  const resultList = [];
  for (let index = 0, indexMax = Math.min(count, to - from + 1); index < indexMax; index++) {
    let next = RANDOM_INT(from, to - index);
    let insertIndex = 0;
    for (;insertIndex < resultList.length && !(resultList[insertIndex] > next); ) {
      next++;
      insertIndex++;
    }
    resultList.splice(insertIndex, 0, next);
  }
  return resultList;
};
const getRandomWithinList = (list, count) => list.length && count >= 0 ? getRandomIntList(0, list.length - 1, count).map((i => list[i])) : [];
const getRandomId = (prefix = "") => `${prefix}${Date.now().toString(36)}-${Math.random().toString(36).slice(2, 10)}`;
const getRandomId62 = (prefix = "") => `${prefix}${encodeB62(Date.now())}${encodeB62(Math.floor(Math.random() * 62 ** 7))}`;
const getRandomId62S = (prefix = "") => `${prefix}${encodeB62S(Date.now())}${encodeB62(Math.floor(Math.random() * 62 ** 7))}`;
const getRandomArrayBuffer = (() => {
  try {
    const {crypto} = globalThis;
    const getRandomArrayBuffer = byteLength => {
      const arrayBuffer = new ArrayBuffer(byteLength);
      for (let index = 0; index < byteLength; index += 65536) crypto.getRandomValues(new Uint8Array(arrayBuffer, index, Math.min(65536, byteLength - index)));
      return arrayBuffer;
    };
    if (32 === getRandomArrayBuffer(32).byteLength) return getRandomArrayBuffer;
  } catch (error) {}
  try {
    const {randomFillSync} = tryRequire("node:crypto");
    const getRandomArrayBuffer = byteLength => {
      const dataView = new DataView(new ArrayBuffer(byteLength));
      randomFillSync(dataView);
      return dataView.buffer;
    };
    if (32 === getRandomArrayBuffer(32).byteLength) return getRandomArrayBuffer;
  } catch (error) {}
  return byteLength => {
    const dataView = new DataView(new ArrayBuffer(byteLength));
    for (let index = 0; index < byteLength; index++) dataView.setUint8(index, RANDOM_INT(0, 255));
    return dataView.buffer;
  };
})();
export { getRandomInt, getRandomIntList, getRandomWithinList, getRandomId, getRandomId62, getRandomId62S, getRandomArrayBuffer };