const getSample = (func, size) => {
  const result = [];
  for (let index = 0; index < size; index++) result.push(func(index));
  return result;
};
const getSampleRange = (from, to) => getSample((index => index + from), to - from + 1);
const getSampleRate = divide => getSample((index => index / divide), 1 + divide);
const getSampleIterator = (func, size) => ({
  [Symbol.iterator]: () => {
    let index = 0;
    return {
      next: () => index < size ? {
        value: func(index++),
        done: !1
      } : {
        value: func(index),
        done: !0
      }
    };
  }
});
const getSampleIteratorRange = (from, to) => getSampleIterator((index => index + from), to - from + 1);
const getSampleIteratorRate = divide => getSampleIterator((index => index / divide), 1 + divide);
export { getSample, getSampleIterator, getSampleRange, getSampleIteratorRange, getSampleRate, getSampleIteratorRate };