import { basicObject, basicFunction, promiseAlike } from "../verify.js";
import { catchPromise } from "../error.js";
const ASYNC_TASK_PHASE_MAP = {
  IDLE: "idle",
  RUN: "run",
  DONE: "done"
};
const PROMISE = "promise";
const QUERY = "query";
const PLAN_PROMISE = "planPromise";
const OUTPUT = "output";
const ASYNC_TASK_KEY_MAP = {
  PLAN: "plan",
  PROMISE: "promise",
  QUERY: "query",
  PLAN_PROMISE: "planPromise",
  OUTPUT: "output"
};
const KEY_RESET = {
  [PLAN_PROMISE]: void 0,
  [QUERY]: void 0,
  [PROMISE]: void 0,
  [OUTPUT]: void 0
};
const getAsyncTaskPhase = asyncTask => asyncTask.output ? "done" : asyncTask.promise ? "run" : "idle";
const runAsyncTask = asyncTask => {
  const planResult = asyncTask.plan(asyncTask);
  planResult !== asyncTask && Object.assign(asyncTask, planResult);
  asyncTask.promise = catchPromise(asyncTask.planPromise).then((output => asyncTask.output = output));
  return asyncTask.promise;
};
const resetAsyncTask = (asyncTask, extra) => ({
  ...asyncTask,
  ...extra,
  ...KEY_RESET
});
export { ASYNC_TASK_PHASE_MAP, ASYNC_TASK_KEY_MAP, getAsyncTaskPhase, runAsyncTask, resetAsyncTask };