import { clamp } from "../math/base.js";
const BLOCK_CHAR_LIST = [ "", "▏", "▎", "▍", "▋", "▊", "▉" ];
const getBlockBar = value => {
  let result = "";
  for (;value > 0; ) {
    result += (rate = value, BLOCK_CHAR_LIST[Math.floor(clamp(rate, 0, 1) * (BLOCK_CHAR_LIST.length - 1))]);
    value -= 1;
  }
  var rate;
  return result;
};
const getBlockChart = ({valueList = [], valueMax = valueList.reduce(((o, v) => Math.max(o, v)), -1 / 0), valueMin = valueList.reduce(((o, v) => Math.min(o, v)), 1 / 0), width = 20}) => valueList.map((value => getBlockBar(clamp(value, valueMin, valueMax) / (valueMax - valueMin) * width)));
export { getBlockBar, getBlockChart };