import { resolve } from "node:path";
import { probeSync, createArgListPack } from "../function.js";
const {getArgs, setArgs, check, verify} = createArgListPack((() => "win32" === process.platform && probeSync([ "C:\\Windows\\System32\\tar.exe", "--version" ], "bsdtar") ? [ "C:\\Windows\\System32\\tar.exe" ] : probeSync([ "tar", "--version" ], "tar") ? [ "tar" ] : void 0), 'expect "tar" in PATH');
const compressArgs = (sourceDirectory, outputFile) => [ ...verify(), outputFile.endsWith("gz") ? "-zcf" : "-cf", resolve(outputFile), "-C", resolve(sourceDirectory), "." ];
const extractArgs = (sourceFile, outputPath) => [ ...verify(), "-xf", resolve(sourceFile), "-C", resolve(outputPath) ];
export { getArgs, setArgs, check, verify, compressArgs, extractArgs };