import { createDummyExot } from "../../common/module/Exot.js";
import { createLoggerExot } from "./Logger.js";
const prefixTime = ({add, ...loggerExot}) => ({
  ...loggerExot,
  add: (...args) => add((new Date).toISOString(), ...args)
});
const configureLog = ({pathLogDirectory, logFilePrefix = ""} = {}) => ({
  loggerExot: prefixTime(pathLogDirectory ? createLoggerExot({
    pathLogDirectory,
    getLogFileName: () => `${logFilePrefix}${(new Date).toISOString().replace(/\W/g, "-")}.log`,
    flags: "a"
  }) : createDummyExot({
    idPrefix: "log-",
    add: console.log,
    save: () => {},
    split: () => {}
  }))
});
export { configureLog };