import { run, runStdout, runSync, runStdoutSync } from "../../run.js";
import { spawnString, probeSync, createArgListPack } from "../function.js";
const {getArgs, setArgs, check, verify} = createArgListPack((() => probeSync([ "git", "--version" ], "git version") ? [ "git" ] : void 0), 'expect "git" in PATH');
const runGit = (argList = [], option) => run([ ...verify(), ...argList ], option);
const runGitSync = (argList = [], option) => runSync([ ...verify(), ...argList ], option);
const runGitStdout = (argList = [], option) => runStdout([ ...verify(), ...argList ], option);
const runGitStdoutSync = (argList = [], option) => runStdoutSync([ ...verify(), ...argList ], option);
const gitString = (...args) => spawnString([ ...verify(), ...args ]);
const squeeze = string => string.replace(/\s/g, "");
const getGitBranch = () => squeeze(gitString("symbolic-ref", "--short", "HEAD") || `detached-HEAD/${gitString("rev-parse", "--short", "HEAD")}`);
const getGitCommitHash = (revisionRange = "HEAD") => squeeze(gitString("log", "-1", "--format=%H", revisionRange));
const getGitCommitMessage = (revisionRange = "HEAD") => gitString("log", "-1", "--format=%B", revisionRange);
export { getArgs, setArgs, check, verify, runGit, runGitSync, runGitStdout, runGitStdoutSync, getGitBranch, getGitCommitHash, getGitCommitMessage };