import { spawnSync } from "node:child_process";
const spawnString = ([command, ...argList]) => String(spawnSync(command, argList).stdout || "");
const probeSync = (argList = [], expect) => spawnString(argList).includes(expect);
const createArgListPack = (getArgList, message) => {
  let args;
  return {
    getArgs: () => args,
    setArgs: (...newArgs) => args = newArgs,
    check: () => {
      void 0 === args && (args = getArgList());
      return Boolean(args);
    },
    verify: () => {
      void 0 === args && (args = getArgList());
      if (!args) throw new Error(message);
      return args;
    }
  };
};
export { spawnString, probeSync, createArgListPack };