const initLoadingMask = () => {
  const {document, qS, cE, Dr: {Common: {Error: {catchAsync}, Function: {lossyAsync}}}} = window;
  return {
    MASK_Z_INDEX: 16777215,
    initialLoadingMaskState: {
      isLoading: !1
    },
    wrapLossyLoading: (loadingMaskStore, func) => lossyAsync((async (...args) => {
      if (!loadingMaskStore.getState().isLoading) {
        loadingMaskStore.setState({
          isLoading: !0
        });
        await catchAsync(func, ...args);
        loadingMaskStore.setState({
          isLoading: !1
        });
      }
    })).trigger,
    renderLoadingMask: loadingMaskStore => {
      const {isLoading} = loadingMaskStore.getState();
      const loadingMaskDiv = qS("#loading-mask");
      if (!isLoading) return loadingMaskDiv && loadingMaskDiv.remove();
      if (!loadingMaskDiv) {
        document.body.appendChild(cE("div", {
          id: "loading-mask",
          style: "position: absolute; top: 0; left: 0; width: 100vw; height: 100vh; background: var(--c-fill-d); opacity: 0; z-index: 16777215; transition: opacity 1s ease;"
        }));
        setTimeout((() => {
          qS("#loading-mask") && (qS("#loading-mask").style.opacity = "0.5");
        }), 200);
      }
    }
  };
};
export { initLoadingMask };