import { AUTH_SKIP } from "../../../module/Auth.js";
import { getRouteParamAny } from "../../Responder/Router.js";
import { responderSendJSON } from "../../Responder/Send.js";
import { getRequestJSON } from "../../function.js";
const PERMISSION_CHECK_ACTION_JSON = "permission:check:action-json";
const PERMISSION_CHECK_ACTION_JSON_PUBLIC = "permission:check:action-json-public";
const setup = async ({name = "feature:action-json", loggerExot, routePrefix = "", featureAuth: {authPack: {authMode}, createResponderCheckAuth}, featurePermission: {permissionPack: {checkPermission = (type, payload) => !0}}, actionMap = {}, actionMapPublic = {}, URL_ACTION_JSON = `${routePrefix}/action-json`, URL_ACTION_JSON_ABBR = `${routePrefix}/ajson`, URL_ACTION_JSON_PUBLIC = `${routePrefix}/action-json-public`, URL_ACTION_JSON_PUBLIC_ABBR = `${routePrefix}/AJSON`, IS_SKIP_AUTH = authMode === AUTH_SKIP}) => {
  const routeList = [ [ [ `${URL_ACTION_JSON}/*`, `${URL_ACTION_JSON_ABBR}/*` ], "POST", createResponderCheckAuth({
    responderNext: async store => {
      const actionType = decodeURIComponent(getRouteParamAny(store) || "");
      const actionFunc = actionMap[actionType];
      if (!actionFunc) return;
      const actionPayload = await getRequestJSON(store);
      return IS_SKIP_AUTH || await checkPermission("permission:check:action-json", {
        store,
        actionType,
        actionPayload
      }) ? responderSendJSON(store, {
        object: await actionFunc(store, actionPayload)
      }) : void 0;
    }
  }) ], [ [ `${URL_ACTION_JSON_PUBLIC}/*`, `${URL_ACTION_JSON_PUBLIC_ABBR}/*` ], "POST", async store => {
    const actionType = decodeURIComponent(getRouteParamAny(store) || "");
    const actionFunc = actionMapPublic[actionType];
    if (!actionFunc) return;
    const actionPayload = await getRequestJSON(store);
    return await checkPermission("permission:check:action-json-public", {
      store,
      actionType,
      actionPayload
    }) ? responderSendJSON(store, {
      object: await actionFunc(store, actionPayload)
    }) : void 0;
  } ] ];
  return {
    actionMap,
    actionMapPublic,
    URL_ACTION_JSON,
    URL_ACTION_JSON_ABBR,
    URL_ACTION_JSON_PUBLIC,
    URL_ACTION_JSON_PUBLIC_ABBR,
    routeList,
    name
  };
};
export { PERMISSION_CHECK_ACTION_JSON, PERMISSION_CHECK_ACTION_JSON_PUBLIC, setup };