import { configureAuth } from "../../../module/Auth.js";
import { responderEndWithStatusCode } from "../../Responder/Common.js";
import { createResponderCheckRateLimit } from "../../Responder/RateLimit.js";
import { getRequestParam } from "../../function.js";
const setup = async ({name = "feature:auth", loggerExot: {add: log}, routePrefix = "", authKey, authSkip = !1, authFile, authFileGroupPath, authFileGroupDefaultTag, authFileGroupKeySuffix, URL_AUTH_CHECK = `${routePrefix}/auth`, URL_AUTH_CHECK_ABBR = `${routePrefix}/a`}) => {
  const authPack = await configureAuth({
    authKey,
    log,
    authSkip,
    authFile,
    authFileGroupPath,
    authFileGroupDefaultTag,
    authFileGroupKeySuffix
  });
  const createResponderCheckAuth = ({responderNext, responderDeny}) => createResponderCheckRateLimit({
    checkFunc: async store => {
      const authToken = await authPack.checkAuth(getRequestParam(store, authPack.authKey));
      store.setState({
        authToken
      });
      return !0;
    },
    responderNext,
    responderDeny
  });
  const routeList = [ [ [ URL_AUTH_CHECK, URL_AUTH_CHECK_ABBR ], "HEAD", createResponderCheckAuth({
    responderNext: store => responderEndWithStatusCode(store, {
      statusCode: 200
    })
  }) ] ];
  return {
    authPack,
    createResponderCheckAuth,
    URL_AUTH_CHECK,
    URL_AUTH_CHECK_ABBR,
    routeList,
    name
  };
};
export { setup };