import { createPathPrefixLock } from "../../../fs/Path.js";
import { responderEndWithStatusCode } from "../../Responder/Common.js";
import { createResponderServeStatic } from "../../Responder/ServeStatic.js";
import { createOnFileChunkUpload } from "../../../module/FileChunkUpload.js";
import { getRequestBuffer } from "../../function.js";
const createResponderServeFile = ({rootPath, responderFallback, extraOption}) => {
  const getPath = createPathPrefixLock(rootPath);
  const responderServeStatic = createResponderServeStatic({
    expireTime: 1e4,
    ...extraOption
  });
  return responderFallback ? (store, relativePath) => responderServeStatic(store, getPath(relativePath)).catch((error => responderFallback(store, {
    error,
    relativePath
  }))) : (store, relativePath) => responderServeStatic(store, getPath(relativePath));
};
const createResponderFileChunkUpload = async ({rootPath, mergePath, loggerExot}) => {
  const fileChunkUpload = await createOnFileChunkUpload({
    rootPath,
    mergePath,
    onError: error => {
      loggerExot.add(`[ERROR][FileChunkUpload] ${error}`);
      console.error(error);
    }
  });
  return async (store, extraFileUploadOption = {}) => {
    await fileChunkUpload({
      bufferPacket: await getRequestBuffer(store),
      ...extraFileUploadOption
    });
    return responderEndWithStatusCode(store, {
      statusCode: 200
    });
  };
};
export { createResponderServeFile, createResponderFileChunkUpload };