import { binary } from "../../../../common/format.js";
import { parseBufferPacket, packBufferPacket } from "../../../data/BufferPacket.js";
import { responderSendBufferCompress } from "../../Responder/Send.js";
import { fetchLikeRequest } from "../../../net.js";
import { getRequestBuffer } from "../../function.js";
const responderServerFetch = async store => {
  const [headerString, requestBodyBuffer] = parseBufferPacket(await getRequestBuffer(store));
  const {url, option = {}} = JSON.parse(headerString);
  const {status, headers, buffer} = await fetchLikeRequest(url, {
    ...option,
    body: requestBodyBuffer
  });
  const responseBodyBuffer = await buffer();
  return responderSendBufferCompress(store, {
    buffer: packBufferPacket(JSON.stringify({
      status,
      headers
    }), responseBodyBuffer)
  });
};
export { responderServerFetch };