import { quickRunletFromStream } from "../../data/Stream.js";
import { requestHttp } from "../../net.js";
const createResponderHTTPRequestProxy = ({getProxyConfig, timeout = 42e3}) => async store => {
  const {proxyUrl, method, headers} = await getProxyConfig(store);
  const response = await requestHttp(proxyUrl, {
    method,
    headers,
    timeout
  }, store.request).promise;
  store.response.writeHead(response.statusCode, response.headers);
  return quickRunletFromStream(response, store.response);
};
export { createResponderHTTPRequestProxy };