import { randomBytes } from "node:crypto";
import { constants as bufferConstants } from "node:buffer";
import { calcHash } from "../../data/Buffer.js";
const FRAME_CONFIG = {
  COMPLETE: [ 8, 15 ],
  FIRST: [ 0, 15 ],
  MORE: [ 0, 0 ],
  LAST: [ 8, 0 ]
};
const OPCODE_TYPE = {
  CONTINUATION: 0,
  TEXT: 1,
  BINARY: 2,
  CLOSE: 8,
  PING: 9,
  PONG: 10
};
const WEBSOCKET_VERSION = 13;
const getRequestKey = () => randomBytes(16).toString("base64");
const getRespondKey = requestKey => calcHash(`${requestKey}258EAFA5-E914-47DA-95CA-C5AB0DC85B11`);
const BUFFER_MAX_LENGTH = bufferConstants.MAX_LENGTH;
const applyMaskQuadletBufferInPlace = (buffer, maskQuadletBuffer, indexOffset = 0) => {
  for (let index = 0, indexMax = buffer.length - indexOffset; index < indexMax; index++) buffer[index + indexOffset] ^= maskQuadletBuffer[3 & index];
};
const packProtocolList = array => array.join(",");
const parseProtocolString = string => (string || "").split(/, */);
export { FRAME_CONFIG, OPCODE_TYPE, WEBSOCKET_VERSION, getRequestKey, getRespondKey, BUFFER_MAX_LENGTH, applyMaskQuadletBufferInPlace, packProtocolList, parseProtocolString };